//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_LED_MODE 
//=====================================================================================

//=======================================================================================
//
//=======================================================================================
void API_LedGpioInitial(void)
{
	// This code for WT56F216 Simple demo board
	// This board has eight LED. 


	rGPIOG_OEN=0x01;
	rGPIOG_DAT=0x01;
	rGPIOF_OEN=0xFF;
	rGPIOF_DAT=0xFF;
	rGPIOG_OEN=0xFF;
	rGPIOG_DAT=0xFF;



}

//=======================================================================================
//
//=======================================================================================
void DisplayLedGroup1(void)
{
//LED Group 1 : GPIOB7~GPIOB5 and GPIOB1
	switch(gbLEDStatus)
	{
		case 0:

		rGPIOF_DAT|=0x01;
		rGPIOF_DAT|=0x02;
		rGPIOF_DAT|=0x04;
		rGPIOG_DAT|=0x08;
		rGPIOG_DAT|=0x10;
		rGPIOG_DAT|=0x20;					

			break;			
		case 1:
		rGPIOF_DAT&=~0x01;
		rGPIOF_DAT|=0x02;
		rGPIOF_DAT|=0x04;
		rGPIOG_DAT|=0x08;
		rGPIOG_DAT|=0x10;
		rGPIOG_DAT|=0x20;	
			
			break;
		case 2:
		rGPIOF_DAT|=0x01;
		rGPIOF_DAT&=~0x02;
		rGPIOF_DAT|=0x04;
		rGPIOG_DAT|=0x08;
		rGPIOG_DAT|=0x10;
		rGPIOG_DAT|=0x20;					
			break;
		case 3:
		rGPIOF_DAT|=0x01;
		rGPIOF_DAT|=0x02;
		rGPIOF_DAT&=~0x04;
		rGPIOG_DAT|=0x08;
		rGPIOG_DAT|=0x10;
		rGPIOG_DAT|=0x20;						
			break;
		case 4:
		rGPIOF_DAT|=0x01;
		rGPIOF_DAT|=0x02;
		rGPIOF_DAT|=0x04;
		rGPIOG_DAT&=~0x08;
		rGPIOG_DAT|=0x10;
		rGPIOG_DAT|=0x20;						
			break;
		case 5:
		rGPIOF_DAT|=0x01;
		rGPIOF_DAT|=0x02;
		rGPIOF_DAT|=0x04;
		rGPIOG_DAT|=0x08;
		rGPIOG_DAT&=~0x10;
		rGPIOG_DAT|=0x20;						
			break;
		case 6:
		rGPIOF_DAT|=0x01;
		rGPIOF_DAT|=0x02;
		rGPIOF_DAT|=0x04;
		rGPIOG_DAT|=0x08;
		rGPIOG_DAT|=0x10;
		rGPIOG_DAT&=~0x20;						
			break;					

			
		default:
			break;
	}

	gbLEDStatus++;
	if(gbLEDStatus>6)
		gbLEDStatus=0;			
#ifdef ENABLE_UARTDEBUG_MODE
	//DRV_Printf("system_timer_flag = %x \r\n",system_timer_flag);
#endif
}
//=======================================================================================
//
//======================================================================================
void DisplayLedGroup2(void)
{
//LED Group 2 : GPIOE7 and GPIOF0~GPIOF2
	switch(LedIndex2)
	{
		case 0 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 1;
		break;
		case 1 :
			GPIOE7_PIN = 0;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 1;
		break;
		case 2 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 0;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 1;
		break;
		case 3 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 0;
			GPIOF2_PIN = 1;
		break;
		case 4 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 0;
		break;
		case 5 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 0;
			GPIOF2_PIN = 1;
		break;
		case 6 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 0;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 1;
		break;
		case 7 :
			GPIOE7_PIN = 0;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 1;
		break;
		case 8 :
			GPIOE7_PIN = 1;
			GPIOF0_PIN = 1;
			GPIOF1_PIN = 1;
			GPIOF2_PIN = 1;
		break;

		}
		LedIndex2++;	
		if(LedIndex2>=9)	LedIndex2 = 0;
}



#endif
