//=====================================================================================
#include "gheader.h"
//=====================================================================================
#ifdef ENABLE_ADC_MODE 
//=====================================================================================




//=====================================================================================
//
//=====================================================================================
//=====================================================================================
void DRV_AnalogKeyInitial(void)
{									    
  	//Init Adcpad I/O function.
	  	//Set AD0 as input
	  	//GPIOA7_PIN_OE = GPIO_INPUT_MODE;    
	  	//GPIOA7_PIN_PHN = GPIO_PULL_LOW;     
		//GPIO_ADC0_IO_FUN_EN=1;
	
	//Set AD1 as input
		//GPIOB0_PIN_OE = GPIO_INPUT_MODE;    
	  	//GPIOB0_PIN_PHN = GPIO_PULL_LOW;     
		//GPIO_ADC1_IO_FUN_EN=1;
	
/*
		//Set AD2 as input
	GPIOB2_PIN_OE = GPIO_INPUT_MODE;    
  	GPIOB2_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC2_IO_FUN_EN=1;
	//Set AD3 as input
	GPIOB3_PIN_OE = GPIO_INPUT_MODE;    
  	GPIOB3_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC3_IO_FUN_EN=1;	
	//Set AD4 as input
	GPIOB4_PIN_OE = GPIO_INPUT_MODE;    
	GPIOB4_PIN_PHN = GPIO_PULL_LOW;    
	GPIO_ADC4_IO_FUN_EN=1;
	//Set AD5 as input
	GPIOB5_PIN_OE = GPIO_INPUT_MODE;   
	GPIOB5_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC5_IO_FUN_EN=1;
	//Set AD6 as input
	GPIOB6_PIN_OE = GPIO_INPUT_MODE;    
	GPIOB6_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC6_IO_FUN_EN=1;
	//Set AD7 as input
	GPIOB7_PIN_OE = GPIO_INPUT_MODE;    
	GPIOB7_PIN_PHN = GPIO_PULL_LOW;     
	GPIO_ADC7_IO_FUN_EN=1;
*/
	//Set AD8 as input
	GPIOC0_PIN_OE = GPIO_INPUT_MODE;    
	GPIOC0_PIN_PHN = GPIO_PULL_LOW;     
	GPC0_FUN_SLT_ADC8();



	//Set  polling mode

	//Power down ADC
	rADC_CTL = 0x80;
	//ADC converter speed 125KHz
	rADC_SEL = 0x80 + VREF_FROM_VDD;
	//Select AD Channel
	rADC_ENCH = ADC_CH8;		//Select ADC channe	
		
}
//=======================================================================================
//
//======================================================================================
WORD API_AverageADCData(BYTE ADC_Channel)
{
#define ADC_SUM_TIME		16	
#define	ADC_SORTING_SIZE	0x03	
	
BYTE R7;

WORD ADC_TotalData;

	ADC_TotalData = 0;
	for(R7=0;R7<ADC_SUM_TIME;R7++)
	{		
		ADC_TotalData = ADC_TotalData + DRV_ReadAnalogChannel(ADC_Channel);	
	}
	ADC_TotalData = ADC_TotalData / ADC_SUM_TIME;	
	return ADC_TotalData; 
}



//=======================================================================================
//
//=======================================================================================
WORD DRV_ReadAnalogChannel(BYTE AD_Channel)
{
	WORD AdcWdata;
	BYTE AdcBdata; 
	
	rADC_SEL = 0x80;
	
	rADC_ENCH = AD_Channel;		//Select ADC channe	
	//rADC_TMPS &= 0xFE;			//Disable EN_ADC_TMPS
	//select VerF
	//rADC_VREF = VREF_FROM_VDD;
	rADC_CTL &= 0x7F;			//Enable low speed adc(bit7=0) 	
	_nop_();
	rADC_CTL |= 0x40;			//=1:Start ADC converter
	do
	{
	_nop_();
	}
	while(rADC_CTL & 0x40);	//1=>0:convert finish
	AdcWdata = 0;
	#if 0
	//For ADC Tool
	PMCTL_DATA[7] = AD_Channel;
	PMCTL_DATA[8] = rADC_DATAH;
	PMCTL_DATA[9] = rADC_DATAL & 0x0F;
	#endif
	AdcBdata = rADC_DATAL;
	AdcBdata = AdcBdata & 0x0F;
	AdcWdata = rADC_DATAH;
	AdcWdata = AdcWdata << 4;
	AdcWdata = AdcWdata + AdcBdata;


	//DRV_Printf("Show rADC_DATAH = %d \r\n",rADC_DATAH);
	//DRV_Printf("Show rADC_DATAL = %d \r\n",rADC_DATAL);	
	return AdcWdata;		
}
//=======================================================================================
//
//=======================================================================================

#endif





//=======================================================================================
//
//=======================================================================================

