#ifndef DRV_ADC_H
#define DRV_ADC_H
//=====================================================================================
#define 	ADC_CH0		0x00
#define 	ADC_CH1		0x01
#define 	ADC_CH2		0x02
#define 	ADC_CH3		0x03
#define 	ADC_CH4		0x04
#define 	ADC_CH5		0x05
#define 	ADC_CH6		0x06
#define 	ADC_CH7		0x07
#define 	ADC_CH8		0x08
#define 	ADC_CH9		0x09
#define 	ADC_CH10		0x0A
#define 	ADC_CH11		0x0B
#define 	ADC_CH12		0x0C
#define 	ADC_CH13		0x0D
#define 	ADC_CH14		0x0E
#define 	ADC_CH15		0x0F



#define VREF_FROM_VDD		0x00
#define VREF_FROM_AREF		0x01
#define VREF_FROM_BANDGAP	0x02
//ADC0 = GPIOA7
#define GPIOA7_PIN   	    DefineBit(rGPIOA_DAT, bit7)
#define GPIOA7_PIN_OE       DefineBit(rGPIOA_OEN, bit7)
#define GPIOA7_PIN_PHN      DefineBit(rGPIOA_PHN, bit7)
//ADC1 = GPIOB1
#define GPIOB0_PIN_OE       DefineBit(rGPIOB_OEN, bit0)
#define GPIOB0_PIN_PHN      DefineBit(rGPIOB_PHN, bit0)
//ADC2 = GPIOB2
#define GPIOB2_PIN_OE       DefineBit(rGPIOB_OEN, bit2)
#define GPIOB2_PIN_PHN      DefineBit(rGPIOB_PHN, bit2)
//ADC3 = GPIOB3
#define GPIOB3_PIN_OE       DefineBit(rGPIOB_OEN, bit3)
#define GPIOB3_PIN_PHN      DefineBit(rGPIOB_PHN, bit3)
//ADC4 = GPIOB4
#define GPIOB4_PIN_OE       DefineBit(rGPIOB_OEN, bit4)
#define GPIOB4_PIN_PHN      DefineBit(rGPIOB_PHN, bit4)
//ADC5 = GPIOB5
#define GPIOB5_PIN_OE       DefineBit(rGPIOB_OEN, bit5)
#define GPIOB5_PIN_PHN      DefineBit(rGPIOB_PHN, bit5)
//ADC6 = GPIOB6
#define GPIOB6_PIN_OE       DefineBit(rGPIOB_OEN, bit6)
#define GPIOB6_PIN_PHN      DefineBit(rGPIOB_PHN, bit6)
//ADC7 = GPIOB7
#define GPIOB7_PIN_OE       DefineBit(rGPIOB_OEN, bit7)
#define GPIOB7_PIN_PHN      DefineBit(rGPIOB_PHN, bit7)
//ADC8 = GPIOC0
#define GPIOC0_PIN_OE       DefineBit(rGPIOC_OEN, bit0)
#define GPIOC0_PIN_PHN      DefineBit(rGPIOC_PHN, bit0)
//ADC9 = GPIOE0
#define GPIOE0_PIN_OE       DefineBit(rGPIOE_OEN, bit0)
#define GPIOE0_PIN_PHN      DefineBit(rGPIOE_PHN, bit0)
//ADC10 = GPIOE1
#define GPIOE1_PIN_OE       DefineBit(rGPIOE_OEN, bit1)
#define GPIOE1_PIN_PHN      DefineBit(rGPIOE_PHN, bit1)
//ADC11 = GPIOE2
#define GPIOE2_PIN_OE       DefineBit(rGPIOE_OEN, bit2)
#define GPIOE2_PIN_PHN      DefineBit(rGPIOE_PHN, bit2)
//ADC12 = GPIOE3
#define GPIOE3_PIN_OE       DefineBit(rGPIOE_OEN, bit3)
#define GPIOE3_PIN_PHN      DefineBit(rGPIOE_PHN, bit3)
//ADC13 = GPIOE4
#define GPIOE4_PIN_OE       DefineBit(rGPIOE_OEN, bit4)
#define GPIOE4_PIN_PHN      DefineBit(rGPIOE_PHN, bit4)
//ADC14 = GPIOE5
#define GPIOE5_PIN_OE       DefineBit(rGPIOE_OEN, bit5)
#define GPIOE5_PIN_PHN      DefineBit(rGPIOE_PHN, bit5)
//ADC15 = GPIOE6
#define GPIOE6_PIN_OE       DefineBit(rGPIOE_OEN, bit6)
#define GPIOE6_PIN_PHN      DefineBit(rGPIOE_PHN, bit6)





//=====================================================================================


void DRV_AnalogKeyInitial(void);

WORD DRV_ReadAnalogChannel(BYTE AD_Channel);
WORD API_AverageADCData(BYTE ADC_Channel);


//=====================================================================================
#endif