#ifndef TYPEDEF_H
#define TYPEDEF_H
//====================================================
typedef unsigned char BYTE;
typedef unsigned int  WORD;
typedef unsigned long DWORD;



#define	uCHAR	unsigned char
#define	sCHAR	signed   char
#define	uINT	unsigned short
#define	sINT	signed   short
#define	uLONG	unsigned long
#define	sLONG	signed long
#define	npage	xdata
#define	zpage	data

typedef unsigned char u8;
typedef unsigned char U8;
typedef unsigned int u16;
typedef unsigned int  U16;


//=============================================================================================
//		TYPEDEFS													
//=============================================================================================
typedef enum {FALSE = 0, TRUE = !FALSE} BoolStatus;

//====================================================
typedef struct
{
  BYTE  bit0 : 1;
  BYTE  bit1 : 1;
  BYTE  bit2 : 1;
  BYTE  bit3 : 1;
  BYTE  bit4 : 1;
  BYTE  bit5 : 1;
  BYTE  bit6 : 1;
  BYTE  bit7 : 1;
} tpBIT;
//====================================================
#define ON        1
#define OFF       0
#define NULL      0
#define null      0
//====================================================
#define SetBit(var, bit_no)     {var |= (1 << bit_no);}
#define ClrBit(var, bit_no)     {var &= ~(1 << bit_no);}
#define GetBit(var, bit_def)    ((var&(1 << bit_def))?1:0)
#define DefineBit(var, bitno)   (((tpBIT *)&var)->bitno)
//====================================================
#endif